
var mWgts = [ page.getWidget('mt'), page.getWidget('mt1'), page.getWidget('mt2')];
var syncWgt = page.getWidget('sync');
var leftPane = page.getWidget('leftPane');
var rightPane = page.getWidget('rightPane');

// save current geometries
var geoms = [];
for(var i=0; i<3; i++) {
    var m = mWgts[i];
    geoms[i] = [m.x, m.y, m.width, m.height];
}


// setup motor objects
var motor1 = new project.GefranMotorClass(mWgts[0]);
var motor2 = new project.GefranMotorClass(mWgts[1]);
var motor3 = new project.GefranMotorClass(mWgts[2]);

function pullerClickButton_onMouseClick(me, eventInfo)
{
    rightPane_close_onMouseClick();
    
    page.getWidget("mt1.motorName").setProperty("fill", "rgb(255,255,255)");
    page.getWidget ("rect2").visible = false;
    page.getWidget ("rect3").visible = false;
    leftPane.x = 17;
    mWgts[1].width = leftPane.width * 0.73;
    mWgts[1].height = leftPane.height * 0.9;
    mWgts[1].x = leftPane.x + (leftPane.width - mWgts[1].width)/3.5;
    mWgts[1].y = leftPane.y + (leftPane.height - mWgts[1].height)/2;
    mWgts[1].visible = true;
    mWgts[2].visible = false;
    leftPane.opacity=1;    
    mWgts[1].opacity=1;
    leftPane.visible = true;    
    
}

function calenderClickButton_onMouseClick(me, eventInfo)
{
    
    rightPane_close_onMouseClick();
    
    page.getWidget("mt2.motorName").setProperty("fill", "rgb(255,255,255)"); 
    page.getWidget ("rect2").visible = false;
    page.getWidget ("rect3").visible = false;
    leftPane.x = 17;
    mWgts[2].width = leftPane.width * 0.73;
    mWgts[2].height = leftPane.height * 0.9;
    mWgts[2].x = leftPane.x + (leftPane.width - mWgts[2].width)/3.5;
    mWgts[2].y = leftPane.y + (leftPane.height - mWgts[2].height)/2;
    mWgts[2].visible = true;
    mWgts[1].visible = false;
    leftPane.opacity=1;    
    mWgts[2].opacity=1;
    leftPane.visible = true;    
}

function extruderClickButton_onMouseClick(me, eventInfo)
{
    leftPane_close_onMouseClick();

    page.getWidget("mt.motorName").setProperty("fill", "rgb(255,255,255)"); 
    page.getWidget ("rect4").visible = false;
    rightPane.x = 542;
    mWgts[0].width = rightPane.width * 0.73;
    mWgts[0].height = rightPane.height * 0.9;
    mWgts[0].x = rightPane.x + (rightPane.width - mWgts[0].width)/1.3;
    mWgts[0].y = rightPane.y + (rightPane.height - mWgts[0].height)/2;
    mWgts[0].visible = true;
    rightPane.visible = true;  
    syncWgt.visible = false;
    rightPane.opacity=1;    
    mWgts[0].opacity=1;
}

function leftPane_close_onMouseClick(me, eventInfo)
{
    leftPane.visible = false;
    page.getWidget ("rect2").visible = true;
    page.getWidget ("rect3").visible = true;
    for(var i=1; i<=2; i++) {
        var m = mWgts[i];
        m.visible = false;
        m.x = geoms[i][0];
        m.y = geoms[i][1];
        m.width = geoms[i][2];
        m.height = geoms[i][3];
    }

    mWgts[1].opacity = 1;
    mWgts[2].opacity = 1;
    mWgts[1].visible = true;
    mWgts[2].visible = true;
    page.getWidget("mt.motorName").setProperty("fill", "rgb(128,128,128)"); 
    page.getWidget("mt1.motorName").setProperty("fill", "rgb(128,128,128)");     
    page.getWidget("mt2.motorName").setProperty("fill", "rgb(128,128,128)");     
}

function rightPane_close_onMouseClick(me, eventInfo)
{    
    rightPane.visible = false;
    page.getWidget ("rect4").visible = true;
    var m = mWgts[0];
    m.visible = false;
    m.x = geoms[0][0];
    m.y = geoms[0][1];
    m.width = geoms[0][2];
    m.height = geoms[0][3];

    syncWgt.visible = true;
    m.visible = true;
    m.opacity = 1;
    page.getWidget("mt.motorName").setProperty("fill", "rgb(128,128,128)"); 
    page.getWidget("mt1.motorName").setProperty("fill", "rgb(128,128,128)");     
    page.getWidget("mt2.motorName").setProperty("fill", "rgb(128,128,128)");      
}

function rightPane_gesture_onGesturePan(me, eventInfo)
{
    print("id: " + eventInfo.id + "dx: " + eventInfo.dx + " " + eventInfo.running);
    if (eventInfo.running == 0 && rightPane.visible) { // slide terminated -> restore settings
        extruderClickButton_onMouseClick(me, eventInfo);
        return;
    }
    

    var dx = Math.min(Math.max(eventInfo.dx, 0), 50);
    rightPane.opacity = 1 - dx/50;
    rightPane.x = 542 + dx;
    mWgts[0].x = 693 + dx;
    mWgts[0].opacity = 1 - dx/50;

    if (dx >= 50) {
        rightPane_close_onMouseClick();
        rightPane.opacity = 1;
        rightPane.x = 542;
    }
}

function leftPane_gesture_onGesturePan(me, eventInfo)
{
    if (eventInfo.running == 0 && leftPane.visible ) { // slide terminated -> restore settings
        if (mWgts[1].visible == true) {
            pullerClickButton_onMouseClick();
        } else {
            calenderClickButton_onMouseClick();
        }

        return;
    }
    
    
    var dx = Math.max(Math.min(eventInfo.dx, 0), -50);
    leftPane.opacity = 1 + dx/50;
    leftPane.x = 17 + dx;
    // move the widget too
    if (mWgts[1].visible == true) {
        mWgts[1].x = 75 + dx;
        mWgts[1].opacity = 1 + dx/50;
    } else {
        mWgts[2].x = 75 + dx;
        mWgts[2].opacity = 1 + dx/50;
    }
    if (dx <= -50) {
        leftPane_close_onMouseClick();
        leftPane.opacity = 1;
        leftPane.x = 17;
    }
}